> For the complete documentation index, see [llms.txt](https://docs.nubrick.app/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nubrick.app/reference/android/remoteconfigvariant.md).

# RemoteConfigVariant

### 定義 <a href="#definition" id="definition"></a>

```kotlin
class RemoteConfigVariant {
    val experimentId: String
    val id: String

    fun get(key: String): String?
    fun getAsString(key: String): String?
    fun getAsBoolean(key: String): Boolean?
    fun getAsInt(key: String): Int?
    fun getAsFloat(key: String): Float?
    fun getAsDouble(key: String): Double?

    @Composable
    fun GetAsEmbedding(
        key: String,
        arguments: Any? = null,
        onEvent: ((event: Event) -> Unit)? = null,
        content: (@Composable (state: EmbeddingLoadingState) -> Unit)? = null
    )
}

class RemoteConfig {
    suspend fun fetch(): Result<RemoteConfigVariant>
}

fun interface RemoteConfigListener {
    fun onResult(result: RemoteConfigResult)
}

class RemoteConfigResult {
    val value: RemoteConfigVariant?
    val error: Throwable?
    val isSuccess: Boolean
}
```

### 基本取得 <a href="#get" id="get"></a>

#### Kotlin / Compose

```kotlin
NubrickSDK.RemoteConfig("FEATURE_FLAGS") { state ->
    when (state) {
        is RemoteConfigLoadingState.Completed -> {
            val variant = state.variant
            val experimentId = variant.experimentId
            val variantId = variant.id

            val title = variant.getAsString("title")
            val enabled = variant.getAsBoolean("is_enabled")
            val maxCount = variant.getAsInt("max_count")
        }
        else -> Unit
    }
}
```

#### Java

`fetchRemoteConfig(...)` は Remote Config を非同期で取得し、取得結果をメインスレッド上で `RemoteConfigListener` に通知します。

```java
import app.nubrick.nubrick.NubrickSDK;
import app.nubrick.nubrick.remoteconfig.RemoteConfigVariant;

NubrickSDK.fetchRemoteConfig("FEATURE_FLAGS", result -> {
    if (!result.isSuccess()) {
        Throwable error = result.getError();
        System.err.println(error);
        return;
    }

    RemoteConfigVariant variant = result.getValue();
    if (variant == null) {
        return;
    }

    String experimentId = variant.getExperimentId();
    String variantId = variant.getId();
    String title = variant.getAsString("title");
    Boolean enabled = variant.getAsBoolean("is_enabled");
    Integer maxCount = variant.getAsInt("max_count");
});
```

取得に成功した場合は `isSuccess()` が `true` になり、`getValue()` から `RemoteConfigVariant` を取得できます。失敗した場合は `getError()` から原因を取得できます。

### Embedding として取得（Compose） <a href="#embedding" id="embedding"></a>

```kotlin
NubrickSDK.RemoteConfig("FEATURE_FLAGS") { state ->
    when (state) {
        is RemoteConfigLoadingState.Completed -> {
            state.variant.GetAsEmbedding(
                key = "hero_component",
                arguments = mapOf("item_id" to itemId)
            )
        }
        else -> Unit
    }
}
```

`GetAsEmbedding(...)` は Jetpack Compose 専用の API です。Java/XML の画面で利用する場合は、アプリモジュールで Kotlin/Jetpack Compose を有効にし、この埋め込み部分だけを Compose で実装して、`ComposeView` を介して既存の XML レイアウトに組み込んでください。

### suspend API で取得（Kotlin） <a href="#suspend" id="suspend"></a>

```kotlin
lifecycleScope.launch {
    val remoteConfig = NubrickSDK.remoteConfig("FEATURE_FLAGS").getOrNull() ?: return@launch
    val variant = remoteConfig.fetch().getOrNull() ?: return@launch
    val message = variant.getAsString("message")
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nubrick.app/reference/android/remoteconfigvariant.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
